unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, Forms, Controls, Graphics, Dialogs, DBGrids, StdCtrls,
  ZConnection, ZDataset;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DBGrid1: TDBGrid;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    ZQuery2: TZQuery;
    ZQuery3: TZQuery;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure ConnectDatabase;
    procedure ConnectQueries;
  public

  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.frm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  ZQuery3.Close;
  ZQuery3.SQL.Text:='Select * from Numbers where num_id =' + ZQuery1.FieldByName('num_id').AsString;
  ZQuery3.Open;

  Form2.ShowModal;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ConnectDatabase;
  ConnectQueries;
end;

procedure TForm1.ConnectDatabase;
begin
  try
    ZConnection1.Connected := True;
  except
    on e: Exception do
      ShowMessage('TForm1.ConnectDatabase: ' + e.Message);
  end;
end;

procedure TForm1.ConnectQueries;
begin
  try
    ZQuery1.SQL.Text :=
      'SELECT num_id, typename, number FROM numbers, types where numbers.type_id = types.type_id;';
    ZQuery1.Open;

    ZQuery2.SQL.Text :=
      'SELECT * FROM types ORDER BY typename ASC;';
    ZQuery2.Open;

  except
    on e: Exception do
      ShowMessage('TForm1.ConnectQueries: ' + e.Message);
  end;
end;

end.






